<?php  namespace Concrete\Package\EzPaypal\Block\EzPaypal;
use \Concrete\Core\Block\BlockController;
use Core;
use Page;

defined('C5_EXECUTE') or die("Access Denied."); 
class Controller extends BlockController
{
    protected $btTable = 'btEzpaypal';
    protected $btInterfaceWidth = "580";
    protected $btWrapperClass = 'ccm-ui';
    protected $btInterfaceHeight = "460";

    public function getBlockTypeDescription()
    {
        return t("Add a PayPal button to your page.");
    }

    public function getBlockTypeName()
    {
        return t("EZ Paypal");
    }
	public function add() {
        $this->edit();
    }
	public function edit() { }
	function getExternalLink() {return $this->externalLink;}
	function getInternalLinkCID() {return $this->internalLinkCID;}
	function getLinkURL() {
		if (!empty($this->externalLink)) {
			return $this->externalLink;
		} else if (!empty($this->internalLinkCID)) {
			$linkToC = Page::getByID($this->internalLinkCID);
			return (empty($linkToC) || $linkToC->error) ? '' : Core::make('helper/navigation')->getLinkToCollection($linkToC);
		} else {
			return '';
		}
	}
	function getExternalLink2() {return $this->externalLink2;}
	function getInternalLink2CID() {return $this->internalLink2CID;}
	function getLinkURL2() {
		if (!empty($this->externalLink2)) {
			return $this->externalLink2;
		} else if (!empty($this->internalLink2CID)) {
			$linkToC = Page::getByID($this->internalLink2CID);
			return (empty($linkToC) || $linkToC->error) ? '' : Core::make('helper/navigation')->getLinkToCollection($linkToC);
		} else {
			return '';
		}
	}
	public function validate($args) {
        $e = Core::make("helper/validation/error");       
		if(empty($args['paypalEmail'])){
            $e->add(t("Paypal Email required."));
        }
		if(empty($args['productName'])){
            $e->add(t("Product Name required."));
        }
		return $e;
	}
	public function save($data) { 
		$data['paypalEmail'] 	= $data['paypalEmail'];
		$data['tooltipText'] 	= $data['tooltipText'];
		$data['productName'] 	= $data['productName'];
		$data['productPrice'] 	= $data['productPrice'];
		$data['productNum'] 	= $data['productNum'];
		$data['buttonLabel'] 	= $data['buttonLabel'];
		$data['mode'] = isset($data['mode']) ? trim($data['mode']) : 'buynow';
		$data['cCode'] = isset($data['cCode']) ? trim($data['cCode']) : 'USD';
		$data['cTarg'] = isset($data['cTarg']) ? trim($data['cTarg']) : 'self';
		$data['btnStyle'] = isset($data['btnStyle']) ? trim($data['btnStyle']) : 'default';

		$data['itemQty'] = is_numeric($data['itemQty']) ? intval($data['itemQty']) : '1';
		$data['taxType'] = isset($data['taxType']) ? trim($data['taxType']) : 'none';
		$data['taxAmt'] = $data['taxAmt'];
		$data['taxRate'] = $data['taxRate'];
		$data['discountType'] = isset($data['discountType']) ? trim($data['discountType']) : 'none';
		$data['discountAmt'] = $data['discountAmt'];
		$data['discountAmt2'] = $data['discountAmt2'];
		$data['discountRate'] = $data['discountRate'];
		$data['discountRate2'] = $data['discountRate2'];
		$data['shipCost'] = $data['shipCost'];
		$data['addShip'] = $data['addShip'];
		$data['unqty'] = ($data['unqty']) ? '1' : '0';
		$data['noShipping'] = isset($data['noShipping']) ? trim($data['noShipping']) : '0';
		$data['trialPeriod'] = isset($data['trialPeriod']) ? trim($data['trialPeriod']) : '0';
		$data['customDamt'] = ($data['customDamt']) ? '1' : '0';
		$data['subsDurD'] = is_numeric($data['subsDurD']) ? intval($data['subsDurD']) : '1';
		$data['subsDurW'] = is_numeric($data['subsDurW']) ? intval($data['subsDurW']) : '1';
		$data['subsDurM'] = is_numeric($data['subsDurM']) ? intval($data['subsDurM']) : '1';
		$data['subsDurY'] = is_numeric($data['subsDurY']) ? intval($data['subsDurY']) : '1';
		$data['trialDur'] = $data['trialDur'];
		$data['trialPrice'] = $data['trialPrice'];
		$data['srcpay'] = is_numeric($data['srcpay']) ? intval($data['srcpay']) : '0';
		$data['srtpay'] = is_numeric($data['srtpay']) ? intval($data['srtpay']) : '2';
		$data['srapay'] = is_numeric($data['srapay']) ? intval($data['srapay']) : '1';
		switch (intval($data['linkType'])) {
			case 1:
				$data['externalLink'] = '';
				break;
			case 2:
				$data['internalLinkCID'] = 0;
				break;
			default:
				$data['externalLink'] = '';
				$data['internalLinkCID'] = 0;
				break;
		}
		unset($data['linkType']);
		switch (intval($data['linkType2'])) {
			case 1:
				$data['externalLink2'] = '';
				break;
			case 2:
				$data['internalLink2CID'] = 0;
				break;
			default:
				$data['externalLink2'] = '';
				$data['internalLink2CID'] = 0;
				break;
		}
		unset($data['linkType2']);
		parent::save($data);
	}
}